#! /bin/bash

if [ $# -ne 3 ]
then
 echo " "
 echo "usage: changeprocesspolicy.sh [process name] [policyname] [priority]"
 echo "Description: used to change to policy and priority of all the "
 echo "threads of a given process."
 echo "[process name] = name of the affected process as it appears in 'ps'"
 echo "[policyname] = OTHER | MTC | RR | FIFO | IO | CALLP | MGMT"
 echo "[priority] = new priority to assign to process"
 echo " "
 exit 0
fi

policy=$2
priority=$3
processName=$1

# Confirm that the necessary binary utility exists
if [ ! -e /nn/bin/changepolicy ]; then
    exit 1
fi

# Produce a shortened processname in event processname exceeds 15 characters.
# This is a requirement due to `ps -A` output.
if [ ${#processName} -gt 15 ]; then
    shortProcessName=${processName:0:15}
else
    shortProcessName=$1
fi

for pidlist in `ps -A -o pid,comm | grep $shortProcessName`
do
    count=`echo $pidlist | grep -c '[0-9]'`
    if [ $count -eq 1 ]
    then
        /nn/bin/changepolicy $pidlist $policy $priority
    fi
done

exit 0
